function [P,L,U]=PALU_Vec(A)
% permuted LU factorization for 3D-array
%   P*A=L*U
  assert( fc_linalg3D.is3Darray(A) )
  [N,m,n]=size(A);
  assert( m==n )
  L=fc_linalg3D.eye(N,m);
  U=A;
  P=fc_linalg3D.eye(N,m);
  K=[1:N]';
  Subs=@(I,J) sub2ind([N,m,n],K,I,J);
  %J=ones(1,N);
  II=repmat([1:m],N,1);
  
  if ~fc_tools.comp.isOctave() && verLessThan('matlab','9.1.0')
    redim=@(A,ncols) repmat(A,[1 1 ncols ]);
  else
    redim=@(A,ncols) A;
  end
  
  for i=1:m-1
    % -> permutations
    [~,idx]=max(abs(U(:,i:end,i)),[],2);
    mu=idx+i-1;
    for j=1:i-1
      idx1=Subs(mu,II(:,j));idx2=Subs(II(:,i),II(:,j));
      IdL=[idx1;idx2];IdR=[idx2;idx1];
      L(IdL)=L(IdR);
      P(IdL)=P(IdR);
    end
    for j=i:m
      idx1=Subs(mu,II(:,j));idx2=Subs(II(:,i),II(:,j));
      IdL=[idx1;idx2];IdR=[idx2;idx1];
      U(IdL)=U(IdR);
      P(IdL)=P(IdR);
    end
    % <- permutations
    kIdx=abs(U(:,i,i))>1e-15;
    for j=i+1:m
      L(kIdx,j,i)=U(kIdx,j,i)./U(kIdx,i,i);
      cols=i:n;
      U(kIdx,j,cols)=U(kIdx,j,cols)-redim(L(kIdx,j,i),length(cols)).*U(kIdx,i,cols);
    end
  end
  if nargout==1, P={P,L,U};end
end
