function B=cholesky_Cpt(A)
% A : N-by-d-by-d, symmetric positive definite matrices
  N=size(A,1);d=size(A,2);
  assert(size(A,3)==d);
  B=zeros(N,d,d);
  for k=1:N
    for j=1:d
      B(k,j,j)=sqrt(A(k,j,j)-sum(abs(B(k,j,1:j-1)).^2));
      for i=j+1:d
        B(k,i,j)=(A(k,i,j)-sum(B(k,i,1:j-1).*conj(B(k,j,1:j-1))))/B(k,j,j);
      end
    end
  end
end
